package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:社会期望量表
 * @date 2021/7/20 15:55
 */
public class MCSDScale extends BaseScale{

    public MCSDScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("MCSDScale.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.MCSDScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //得分
        int score = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    score += 1;
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")){
                if (jsonObject1.getString("checkItems").equals("否")) {
                    score += 1;
                }
            }
        }
        System.out.println("得分：" + score);
        DecimalFormat df   = new DecimalFormat("######0.00");
        //大学生标准分
        double score1 = Double.parseDouble(df.format(50+10*(score-15.5)/4.4));
        //普通人标准分
        double score2 = Double.parseDouble(df.format(50+10*(score-28.4)/6.5));
        //抑郁者标准分
        double score3 = Double.parseDouble(df.format(50+10*(score-20.9)/5.3));
        Map<String, String> resultMap1 = new LinkedHashMap<>();
        resultMap1.put("大学生得分", String.valueOf(score1));
        resultJson.put("大学生得分", String.valueOf(score1));
        //根据得分判断信任度
        if (score1 >= 60){
            resultMap1.put("大学生社会期望", "高");
            resultJson.put("大学生社会期望", "高");
        }else if (score1 >= 30 && score1 < 60){
            resultMap1.put("大学生社会期望", "中");
            resultJson.put("大学生社会期望", "中");
        }else if (score1 < 30){
            resultMap1.put("大学生社会期望", "低");
            resultJson.put("大学生社会期望", "低");
        }
        //得分列表
        Map<String, String> resultMap2 = new LinkedHashMap<>();
        resultMap2.put("普通人得分", String.valueOf(score2));
        resultJson.put("普通人得分", String.valueOf(score2));
        //根据得分判断信任度
        if (score2 >= 60){
            resultMap2.put("普通人社会期望", "高");
            resultJson.put("普通人社会期望", "高");
        }else if (score2 >= 30 && score2 < 60){
            resultMap2.put("普通人社会期望", "中");
            resultJson.put("普通人社会期望", "中");
        }else if (score2 < 30){
            resultMap2.put("普通人社会期望", "低");
            resultJson.put("普通人社会期望", "低");
        }
        //得分列表
        Map<String, String> resultMap3 = new LinkedHashMap<>();
        resultMap3.put("抑郁者得分", String.valueOf(score3));
        resultJson.put("抑郁者得分", String.valueOf(score3));
        //根据得分判断信任度
        if (score3 >= 60){
            resultMap3.put("抑郁者社会期望", "高");
            resultJson.put("抑郁者社会期望", "高");
        }else if (score3 >= 30 && score3 < 60){
            resultMap3.put("抑郁者社会期望", "中");
            resultJson.put("抑郁者社会期望", "中");
        }else if (score3 < 30){
            resultMap3.put("抑郁者社会期望", "低");
            resultJson.put("抑郁者社会期望", "低");
        }
        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap1);
        resultMapList.add(resultMap2);
        resultMapList.add(resultMap3);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_MCSD);
        returnJson.put("resultJson",resultJson);

        resultJson.put("测试结果指导", "此结果分为三类，请按照自己情况查看对应结果");
        return returnJson;
    }
}
